#!/usr/bin/perl
#$Id: analytic_updater.pl,v 1.5 2012/12/27 09:16:37 sofc Exp $
use strict;
use warnings;
use LWP::Simple;
use LWP::UserAgent;
use HTTP::Request;
use HTTP::Response;
use HTML::LinkExtor; # allows you to extract the links off of an HTML page.
use SemaforeFile;
use Impedance::Header;

my $debug = 0;
my $user = $<;
if ($user != 0)
{
    print "must be root to run!\n";
    if (!$debug)
    {
        exit 0;
    }
}

my $hostfile = SemaforeFile->new('/home/analytic/update_host.txt');
my @lines = $hostfile->readlines();
die "No host information found!" unless (@lines > 2);
my $host = $lines[0];
my $path = $lines[1];
my $file = $lines[2];
my $keyfile = 'http://'.$host.$path.$file;
my $local_build = SemaforeFile->new('/home/analytic/analytic_build');
$local_build->open_read;
my $local_version = $Impedance::Header::VERSION.'-'.$local_build->readline;
$local_build->close;
chomp $local_version;

my $mode = '';
my $modefile = SemaforeFile->new('/home/analytic/install_mode.txt');
if ($modefile->exist)
{
    $modefile->open_read();
    my $txt = $modefile->readline;
    $modefile->close;
    $mode = $txt if ($txt);
}

my $browser = LWP::UserAgent->new();
$browser->timeout(10);

my $t = localtime();
print $t,"\n";
print "Fetching version from $keyfile\n";
my $request = HTTP::Request->new(GET => $keyfile);
my $response = $browser->request($request);
if ($response->is_error()) {
    printf "%s\n", $response->status_line;
    exit;
}
my $content = $response->content();
chomp $content;
if ($content eq $local_version)
{
    print "ElchemeaAnalytic system up to date\n";
    exit;
}
if ($content =~ /^([\d\.]+)/)
{
    my $v = $1;
    my $f = 'http://'.$host.$path.'ElchemeaAnalytic-'.$v.'.tgz';
    print "Fetching new version from $f using wget\n";
    my $cmd = '/usr/bin/wget '.$f.' -O /root/ElchemeaAnalytic-'.$v.'.tgz';
    system($cmd);
    chdir '/root/';
    $cmd = '/bin/tar -xzf ElchemeaAnalytic-'.$v.'.tgz';
    print "Extracting new source.....\n";
    system($cmd);
    chdir 'ElchemeaAnalytic/';
    system('make');
    if ($? == -1)
    {
	print "Make failed! aborting update.\n";
	exit 1;
    }
    if ($mode =~ /cmdonly/i)
    {
	system('make update_cmdonly');
    }
    else
    {
	system('make update');
    }
    if ($? == -1)
    {
	print "Make update failed! System possibly in an incomplete/undefined state!.\n";
	exit 1;
    }
    my $string = "ElchemeaAnalytic system updated to version $content";
    print "\nDone udating ElchemeaAnalytic!\n\n";
}
