#!/usr/bin/perl -T
use strict;
use warnings;
use Impedance::Model;
use Impedance::IMPCGI qw(:html :cgi);
use CGI qw(:standard :netscape);
&print_header("Elchemea Analytical");
my $offset = get_CGI_value_clean('offset');
my $length = get_CGI_value_clean('length');
my $type = get_CGI_value_clean('type');
my $model = Impedance::IMPCGI::format_model(get_CGI_value('text'));
my $m = Impedance::Model->new();
$m->parse($model) if ($model);
param(-name=>'model',-value=>$model);
if ($type)
{
    print start_form(-name=>'sofc',-method=>'get');
    print_hidden();
    print hidden(-name=>'offset',-value=>$offset,-force=>1);
    print hidden(-name=>'orgoffset',-value=>$offset,-force=>1);
    print hidden(-name=>'length',-value=>$length,-force=>1);
    print hidden(-name=>'orglength',-value=>$length,-force=>1);
    print hidden(-name=>'text');
    print hidden(-name=>'filename');
    print hidden(-name=>'filedata');
    print hidden(-name=>'fit_res');
    print hidden(-name=>'type',-value=>undef,-force=>1);
    print hidden(-name=>'allow_close',-value=>1,-force=>1);
    print end_form();
    my $id = $m->add_element($type);
    print center(h1('Add '.$id->type.' element to model:'));
    print '<center><table border=0 cellpadding=10><tr>';
    print '<tr><td colspan=3><hr></td></tr>';
    print '<tr><td></td>';
    top_nav_bar_button_js('','add_element','Add element',undef,'s1','add_element_start()');
    print '</tr>';
    print '<tr><td></td><td>';
    print button(-name=>'ok',-id=>'return_btn',-value=>'Ok',-class=>'s3',-onclick=>'set_ok()');
    print '</td></tr>';
    print '</table></center>';
    my $start = '[';
    my $end = ']';
    if ($type =~ /par/i)
    {
	$start = '(';
	$end = ')';
    }
    &print_model_js_manipulate($start,$end);
}
else
{
    my $m2 = Impedance::Model->new();
    my $id = $m->element(1);
    unless ($id)
    {
	print h3({-class=>'Alert'},"Error: No model element found!");
	print end_html();
	exit;
    }
    my @l = ();
    foreach my $e ($id->elements())
    {
	push @l,$id->element($e)->print_line;
    }
    $m2->parse(join("\n",@l));
    param(-name=>'model',-value=>($m2->print_model));
    print start_form(-name=>'sofc',-method=>'get');
    print_hidden();
    print hidden(-name=>'offset',-value=>$offset,-force=>1);
    print hidden(-name=>'orgoffset',-value=>$offset,-force=>1);
    print hidden(-name=>'length',-value=>$length,-force=>1);
    print hidden(-name=>'orglength',-value=>$length,-force=>1);
    print hidden(-name=>'text');
    print hidden(-name=>'filename');
    print hidden(-name=>'filedata');
    print hidden(-name=>'fit_res');
    print hidden(-name=>'type');
    print hidden(-name=>'allow_close',-value=>1,-force=>1);
    print end_form();
    print center(h1('Edit '.lc($id->type).' element:'));
    print center(h3($m->model_text));
    print '<center><table border=0 cellpadding=10><tr>';
    print '<tr><td colspan=3><hr></td></tr>';
    foreach my $e ($m2->elements)
    {
        print '<tr>';
	Impedance::IMPCGI::p_element($m2->element($e));
        print '</tr>';
        print '<tr><td colspan=3><hr></td></tr>';
    }
    print '<tr><td></td>';
    top_nav_bar_button_js('','add_element','Add element',undef,'s3','add_element_start()');
    print '</tr>';
    print '<tr><td></td><td>';
    print button(-name=>'ok',-id=>'return_btn',-value=>'Ok',-class=>'s3',-onclick=>'set_ok()');
    print '</td></tr>';
    print '</table></center>';
    my $start = '[';
    my $end = ']';
    if ($id->type =~ /par/i)
    {
	$start = '(';
	$end = ')';
    }
    &print_model_js_manipulate($start,$end);
}

print end_html();
exit;

sub print_model_js_manipulate($$)
{
    my $start = shift;
    my $end = shift;
    print <<END;

<script language=javascript>

function start_marker()
{
    return "$start";
}

function end_marker()
{
    return "$end";
}

function add_element_start()
{
    IMP_open('model.cgi',500,400,50,50);
}

function set_ok()
{
    var m = '$start' + "\\n" +  document.sofc.model.value + "\\n" + '$end';
    document.sofc.length.value = document.sofc.orglength.value;
    document.sofc.offset.value = document.sofc.orgoffset.value;
    if (document.sofc.length.value == 0)
    {
	opener.document.sofc.model.value += "\\n" + m;
    }
    else
    {
	var mod = opener.document.sofc.model.value;
	var modarr = mod.split("\\n");
	var newarr = new Array;
	var newmod;
	for (x = 0; x < document.sofc.offset.value;x++)
	{
	    newarr.push(modarr[x]);
	}
	newmod = newarr.join("\\n") + "\\n" + m + "\\n";
	newarr.length = 0;
	var y = parseInt(document.sofc.offset.value) + parseInt(document.sofc.length.value) + 0;
	for (x = y; x < modarr.length; x++)
	{
	    newarr.push(modarr[x]);
	}
	newmod += newarr.join("\\n");
	opener.document.sofc.model.value = newmod;
    }
    opener.document.sofc.type.value = '';
    opener.document.sofc.length.value = opener.document.sofc.orglength.value;
    opener.document.sofc.offset.value = opener.document.sofc.orgoffset.value;
    opener.document.sofc.text.value = opener.start_marker() + "\\n" + opener.document.sofc.model.value + "\\n" + opener.end_marker();
    opener.document.sofc.submit();
    self.close();
}

function add_element_go()
{
    document.sofc.length.value = document.sofc.orglength.value;
    document.sofc.offset.value = document.sofc.orgoffset.value;
    document.sofc.text.value = '$start' + "\\n" + document.sofc.model.value + "\\n" +'$end';
    document.sofc.submit();
}

function delete_element(e)
{
    if (!confirm("Delete element "+e.name))
        return false;
    var arr = e.name.split("_");
    mod = document.sofc.model.value;
    var modarr = mod.split("\\n");
    var res = new Array;
    for (x = 0; x < modarr.length;x++)
    {
        if (x != arr[1]-1)
            res.push(modarr[x]);
    }
    document.sofc.model.value = res.join("\\n");
    document.sofc.text.value = '$start' + "\\n" + document.sofc.model.value + "\\n" +'$end';
    document.sofc.submit();
}

function set_new_val(e)
{
    var arr = e.name.split("-");
    var val = e.value;
    mod = document.sofc.model.value;
    var modarr = mod.split("\\n");
    var line = modarr[arr[0]-1];
    var linedef = line.split(": ");
    var elements = linedef[1].split(", ");
    for (x = 0; x < elements.length;x++)
    {
        var item = elements[x].split("=");
        if (item[0] == arr[1])
        {
            elements[x] = item[0]+'='+val;
        }
    }
    linedef[1] = elements.join(", ");
    modarr[arr[0]-1] = linedef.join(": ");
    document.sofc.model.value = modarr.join("\\n");
    document.sofc.text.value = '$start' + "\\n" + document.sofc.model.value + "\\n" +'$end';
    document.sofc.submit();
}

function add_complex(t)
{
    var model = '';
    var nr = 0;
    var length = 0;
    document.sofc.offset.value = nr;
    document.sofc.length.value = length;
    document.sofc.text.value = model;
    document.sofc.type.value = t;
    var btn = document.getElementById('return_btn');
    btn.disabled = true;
    document.sofc.allow_close.value = 0;
    CPLE_open('complex_add.cgi',700,600,500,50);
}

function edit_complex(e)
{
    var model = document.getElementById('model_'+e.name);
    var nr = document.getElementById('nr_'+e.name);
    var length = document.getElementById('length_'+e.name);
    document.sofc.offset.value = nr.value;
    document.sofc.length.value = length.value;
    document.sofc.text.value = model.value;
    document.sofc.type.value = '';
    document.sofc.allow_close.value = 0;
    CPLE_open('complex_add.cgi',700,600,500,50);
}

</script>

END

}
